/'
 DrwGfxCtrl.bi
 
 This file contains a few routines (including the needed type-definitions) to draw some gui-elements.
 Unfortunately, this module is still in to-do-state. There are lot's of routines on my HDD, which are only
 waiting for the day, they can be added to this file. But some work has to be done, before they're ready, and
 so, you can find only these...
 Anyway, even these routines should be updated...
 
 DrwDlg (Caption AStr, _
         Text    AStr = "", _
         posi    As DGC.Rect, _
         fore    AInt = CL_Black, _
         back    AInt = CL_White)
    Draws a Window whose Title is first line of 'Text' the rest of 'Text is shown in the window itself.
    'posi' indicates the position and size on screen.
    'fore' and 'back' are the colors, the window is drawn in.
      The Titlebar is drawn in CL_D_Blue. This means, the routine can't be used in a screen mode with less than
      15bpp.
 
 DrwButton (Caption  AStr, _
            posi     As DGC.Rect, _
            ColorBtn AInt = CL_M_Gray, _
            ColorTxt AInt = CL_Black)
   Draws a button using DrwButtonForm and DrwAlignedText (see below).
   'Caption' is the text, shown on the button. It'll be placed centered on the button and may be multiline.
   'posi' indicates the position and size of the button.
   'ColorBtn' and 'ColorTxt' are the colors of the button. This routine may be used in any Gfx-Mode, even in
      modes with less than 15bpp.
   'inverse' is a flag that either has to be zero or non-zero. If it is non-zero, the button will be shown
      sunken.
 
 DrwButtonForm (posi    As DGC.Rect, _
               col      AInt = CL_M_Gray, _
               inverse  AInt = 0)
   Draws the form of an button, but does not place any text on it. This is used by DrwButton.
   'posi' indicates the position and size of the button.
   'col' is the color of the button. This func may be used in any Gfx-Mode, even in modes with less than 15bpp.
   'inverse' is a flag that either has to be zero or non-zero. If it is non-zero, the button will be shown
      sunken.
 
 
 DrwAlignedText (Caption   AStr, _
                 posi      As DGC.Rect, _
                 align     AInt = DGC.Al_Left, _
                 fore      AInt = 0, _
                 back      AInt = -1)
   Places some Text on screen in a certain region. Allows horizontal alignment.
   'posi' indicates the position and size of the region, the text will be placed in. Note: Vertical text align-
      ment will always be centered (for this version...)
   'align' is the horizontal alignment of the text. Use the Enum DGC.Alignment for certain values.
   'fore' and 'back' are the colors of the region. If back is -1, no background will be drawn.
 
 DrwScroll (v        AInt, _
            max      AInt, _
            posi     As DGC.Rect, _
            col      AInt = CL_M_Gray, _
            hscroll  AInt = 0)
   Draws a scrollbar on screen.
   'v' is the value, that should be shown.
   'max' is the maximum value, that the bar should be able to show. It is needed to calculate, where the bar-
      indicator should be placed, and how big it should be.
   'posi' indicates position and size of the bar.
   'hscroll' is a flag that either has to be zero or non-zero. If it is non-zero, the bar will be horizontal,
      otherwise it'll be vertical.
'/

#IfNDef CommonStatements_DGC
   #Define CommonStatements_DGC
   NameSpace DGC
      Type Rect
         x1 AInt
         y1 AInt
         x2 AInt
         y2 AInt
      EType
      
      Enum Alignments
         Al_Left
         Al_Center
         Al_Right
      End Enum
   End NameSpace
#EndIf

#IfNDef CommonStatements_DTC
   #Define CommonStatements_DTC
   NameSpace DTC
      Type Rect
         l AInt
         t AInt
         w AInt
         h AInt
      EType
   End NameSpace
#EndIf

DProc    DrwDlg         (Caption AStr, Text AStr = "",  posi As DGC.Rect, fore      AInt = CL_Black,  back     AInt = CL_White)

DProc    DrwButton      (Caption AStr,                  posi As DGC.Rect, ColorBtn  AInt = CL_M_Gray, ColorTxt AInt = CL_Black, inverse AInt = 0)
   DProc DrwButtonForm  (                               posi As DGC.Rect, col       AInt = CL_M_Gray, inverse AInt = 0)
   DProc DrwAlignedText (Caption AStr,                  posi As DGC.Rect, align AInt = DGC.Al_Left, fore AInt = 0, back AInt = -1)

DProc    DrwScroll(v AInt, max AInt, posi As DGC.Rect, col AInt = CL_M_Gray, hscroll AInt = 0)
'=============================================================================='

Sub DrwDlg (Caption AStr, Text AStr = "", posi As DGC.Rect, fore AInt = CL_Black, back AInt = CL_White)
   DInt oldHeight, tx, ty
   DSTr txt
   
   With posi
      Line (.x1, .y1)-(.x2, .y2                    ), back, BF
      Line (.x1, .y1)-(.x2, .y1 + DWX_StdFontHeight), CL_D_Blue, BF
      Line (.x1, .y1)-(.x2, .y2                    ), fore, B
      
      tx = .x1 : ty = .y1
      DwX GetTextLine(Caption, 1), tx, ty + 2, CL_White
   EWith
   
   oldHeight = posi.y2
   posi.y1 += DWX_StdFontHeight
   posi.y2 = posi.y1 + GetTextHeight(Text)
   If posi.y2 > oldHeight Then posi.y2 = (oldHeight \ DWX_StdFontHeight) * DWX_StdFontHeight
   
   DrwAlignedText Text, posi, DGC.Al_Left, fore
End Sub
'------------------------------------------------------------------------------'
Sub DrwButton(Caption AStr, posi As DGC.Rect, btn AInt, txt AInt, inverse AInt = 0)
   DrwButtonForm posi, btn, inverse
   DrwAlignedText Caption, posi, DGC.Al_Center, txt
End Sub
'..............................................................................'
Sub DrwButtonForm (p As DGC.Rect, c AInt, inverse AInt = 0)
   DInt bbc, br, bg, bb
   DInt dbc, dr, dg, db
   DInt transp
   
   ' Get Colours:
   If c = -1 Then transp = -1 : c = CL_M_Gray
   bbc = c
   br = bbc And &HFF0000 : bg = bbc And &H00FF00 : bb = bbc And &H0000FF
   br -= &H440000 : If br < 0 Then br = 0
   bg -= &H004400 : If bg < 0 Then bg = 0
   bb -= &H000044 : If bb < 0 Then bb = 0
   bbc = br Or bg Or bb
   dbc = c
   dr = dbc And &HFF0000 : dg = dbc And &H00FF00 : db = dbc And &H0000FF
   dr -= &H880000 : If dr < 0 Then dr = 0
   dg -= &H008800 : If dg < 0 Then dg = 0
   db -= &H000088 : If db < 0 Then db = 0
   dbc = dr Or dg Or db
   
   If inverse Then Swap bbc, dbc
   
   ' Draw
   If Not transp Then Line (p.x1, p.y1)-(p.x2, p.y2), c, BF
   Line (p.x1    , p.y1    )-(p.x1    , p.y2    ), bbc  ' bright border-side
   Line (p.x1 + 1, p.y1 + 1)-(p.x1 + 1, p.y2 - 1), bbc
   Line (p.x1    , p.y1    )-(p.x2    , p.y1    ), bbc
   Line (p.x1 + 1, p.y1 + 1)-(p.x2 - 1, p.y1 + 1), bbc
   Line (p.x2    , p.y1    )-(p.x2    , p.y2    ), dbc  ' dark border-side
   Line (p.x2 - 1, p.y1 + 1)-(p.x2 - 1, p.y2 - 1), dbc
   Line (p.x2    , p.y2    )-(p.x1    , p.y2    ), dbc
   Line (p.x2 - 1, p.y2 - 1)-(p.x1 + 1, p.y2 - 1), dbc
End Sub
'..............................................................................'
Sub DrwAlignedText (Caption AStr, p As DGC.Rect, align AInt = DGC.Al_Left, fore AInt = 0, back AInt =-1)
   DStr tmpC
   DInt TextWidth, TextHeight, BoxWidth, BoxHeight, i
   DInt addFlag
   DInt tx, ty, th
   
   ' Get Caption and accommodate length and height
   With p
      TextWidth  = GetTextWidth(Caption)
      TextHeight = GetLineCount(Caption)
      BoxWidth   =  .x2 - .x1
      BoxHeight  = (.y2 - .y1) \ DWX_StdFontHeight                ' Height in Lines
      addFlag    = -1
      th         =  1
      If (TextWidth > BoxWidth) Or (TextHeight > BoxHeight) Then  ' accommodate
         If BoxHeight = 1 Then Caption = GetTextLine(Caption, 1)
         For i = 1 To Len(Caption)
            If Caption[i - 1] = 13 Then
               If th = BoxHeight Then QFor
               th += 1
               addFlag = -1
               tmpC += Chr(13)
            Else
               If addFlag = -1 Then tmpC += Mid(Caption, i, 1)
               If GetTextWidth(tmpC) > BoxWidth Then 
                  tmpC = Left(tmpC, i - 1)
                  addFlag = 0
               EIf
            EIf
         Next
         TextHeight  = th
         Caption     = tmpC
      EIf
      TextHeight *= DWX_StdFontHeight                 ' real height in pixels
      ty = (.y2 - .y1 - TextHeight) \ 2 + .y1
      For i = 1 To GetLineCount(Caption)
         tmpC = GetTextLine(Caption, i)
         TextWidth = GetTextWidth(tmpC)
         SelC align
         Case DGC.Al_Left
            tx = .x1
         Case DGC.Al_Right
            tx = .x2 - TextWidth
         Case DGC.Al_center
            tx = .x1 + (BoxWidth - TextWidth) \ 2
         ESel
         If Not back Then Line (p.x1, p.y1)-(p.x2, p.y2), back, BF
         DwX tmpC, tx, ty, fore
      Next
   EWith
End Sub
'------------------------------------------------------------------------------'
Sub DrwScroll(v AInt, max AInt, posi As DGC.Rect, col AInt = CL_M_Gray, hscroll AInt = 0)
   DInt h, hScr, hMov, hInd, pInd, half
   DSng part
   DA DGC.Rect BtnPos
   
   ' +-+
   ' |^| ------------> Btn. H = 16
   ' +-+
   ' |=| ---+----+
   ' |=|    |    |
   ' |=|    +--------> hScr = Total Height - 2 * Height of Btn 
   ' |=|    |    |
   ' |=|    |    +---> hInd = hScr \ No._of_Vals_to_Indicate, but minimum 5.
   ' |=|    |    |
   ' |=| ---|----+
   ' | | ---|--+
   ' | |    |  |
   ' | |    |  |
   ' | |    |  +-----> hMov = hScr - hInd
   ' | |    |  |
   ' | | ---+--+
   ' +-+
   ' |V| ------------> Btn. H = 16
   ' +-+
   '
   ' pInd = position of Indicator
   ' half = half width/height of Btn
   
   part = v / max
   BtnPos = posi
   
   If hScroll Then
      With posi
         hScr = .x2 - .x1 - 32     ' - 32 = - 2 * 16 => Up/Down-Button 
         hInd = hScr \ max
         If hInd <= 5 Then hInd = 5
         hMov = hScr - hInd
         
         pInd = part * hMov
         If pInd + 5 > hScr Then pInd = hScr - 5
         
         Line (.x1, .y1) - (.x2, .y2), col, BF
         
         BtnPos.x2 = .x1 + 15
         DrwButtonForm BtnPos, col
         half = (.y2 - .y1) \ 2
         With BtnPos
            Line ( .x1 + 13, .y1 +    3 ) - ( .x2 - 13, .y1 + half ), CL_Black
            Line ( .x2 - 13, .y2 - half ) - ( .x1 + 13, .y2 -    3 ), CL_Black
         EWith
         BtnPos.x2 = .x2
         BtnPos.x1 = .x2 - 15
         DrwButtonForm BtnPos, col
         With BtnPos
            Line ( .x2 - 13, .y1 +    3 ) - ( .x1 + 13, .y1 + half ), CL_Black
            Line ( .x1 + 13, .y2 - half ) - ( .x2 - 13, .y2 -    3 ), CL_Black
         EWith
         
         BtnPos.x1 = .x1 + 16 + pInd
         BtnPos.x2 = .x1 + 16 + pInd + hInd
         DrwButtonForm BtnPos, col
      EWith
      
   Else
      With posi
         hScr = .y2 - .y1 - 32     ' - 32 = - 2 * 16 => Up/Down-Button 
         hInd = hScr \ max
         If hInd <= 5 Then hInd = 5
         hMov = hScr - hInd
         
         pInd = part * hMov
         If pInd + 5 > hScr Then pInd = hScr - 5
         
         Line (.x1, .y1) - (.x2, .y2), col, BF
         
         BtnPos.y2 = .y1 + 15
         DrwButtonForm BtnPos, col
         half = (.x2 - .x1) \ 2
         With BtnPos
            Line ( .x1 +    3, .y1 + 13 ) - ( .x1 + half, .y2 - 13 ), CL_Black
            Line ( .x2 - half, .y2 - 13 ) - ( .x2 -    3, .y1 + 13 ), CL_Black
         EWith
         BtnPos.y2 = .y2
         BtnPos.y1 = .y2 - 15
         DrwButtonForm BtnPos, col
         With BtnPos
            Line ( .x1 +    3, .y2 - 13 ) - ( .x1 + half, .y1 + 13 ), CL_Black
            Line ( .x2 - half, .y1 + 13 ) - ( .x2 -    3, .y2 - 13 ), CL_Black
         EWith

         BtnPos.y1 = .y1 + 16 + pInd
         BtnPos.y2 = .y1 + 16 + pInd + hInd
         DrwButtonForm BtnPos, col
      EWith
      
   EIf
   
End Sub
'------------------------------------------------------------------------------'

