/'
 DrwTxtCtrl.bi
 
 This file contains a few routines that draw Controlls in Text modes by given properties like caption or position.
 
 + DrwTxtButton(Caption AStr, posi As DTC.Rect, col AInt)
      Caption - A String that is shown as caption of the button.
                it is automatically centered, and shortened, if it doesn't fit into 
                the button.
                This String may be multiline; use an Chr(13) for a linebreak.
      posi - the coordinates and dimensions of the button. top, left, width and height.
      col - color of the button.
            forecolor Or (background Shl 4)
            e.g. &H4E for yellow on red.
            
 + DrwTxtDlg   (Caption AStr, Text AStr = "", posi As DTC.Rect, col AInt)
      Caption - see DrwButton, but single-line and not centered.
      Text - Text to be shown in the Box, formatted as caption in DrwButton.
      posi - see DrwTxtButton
      col - colors of the Box.
            titlefore Or (titleback Shl 4) Or (foreColor Shl 8) Or (background Shl 12)
            e.g. &HF01E for black on white, title yellow on blue.
            
 + DrwTxtScroll(v AInt, max AInt, posi As DTC.Rect, col AInt = &H70, hscroll AInt = 0)
      v - value to show
      max - max value for this bar
      posi - position for the bar. Either w or h is 1, depending on hscroll.
      col - color of the bar.
            forecolor Or (background Shl 4)
            e.g. &H78 for black on gray.
      hscroll - indicates that scroll bar has to be horizontal
 + InpEx (...)
      Prompt - Question Text
      l and c - line and column for the box
      ans - the answer will be repeated in this variable. It may be used to set an default
            answer.
      col - the text-color.
            foreground or (background Shl 8)
            e.g. 1F for white on blue
      Flags - see gfxstring.bi DWI-defines for flags
      maxlen - max length of ans to be repeated
      cursor - position of the cursor. If set to zero, no cursor will be used.
      MaxShowLength - The max length of ans to be shown at once. If ans is longer than this,
                      ans will be scrolled.
'/

#IfNDef CommonStatements_DTC
   #Define CommonStatements_DTC
   NameSpace DTC
      Type Rect
         l AInt
         t AInt
         w AInt
         h AInt
      EType
   End NameSpace
#EndIf

#IfNDef CommonInc_Constants
   #Define kc_return Chr(13)
#EndIf

DProc DrwTxtButton(Caption AStr, posi As DTC.Rect, col AInt)
DProc DrwTxtDlg   (Caption AStr, Text AStr = "", posi As DTC.Rect, col AInt)
DProc DrwTxtScroll(v AInt, max AInt, posi As DTC.Rect, col AInt = &H70, hscroll AInt = 0)

DProc InpEx   ( Prompt  AStr = ""         , _
                ByRef l             AInt        , _
                ByRef c             AInt        , _
                ByRef Ans           AStr  = ""  , _
                col                 AInt  = &H0F, _
                Flags               AInt  =  0  , _
                maxLen              AInt  =  0  , _
                Cursor              AInt  =  0  , _
                MaxShowLength       AInt  =  0    _
               )
'=============================================================================='

Sub DrwTxtButton(Caption AStr, posi As DTC.Rect, col AInt)
   DInt l, h, i
   DInt oCol, lsp, csp
   DStr tmp
   
   With posi
      h = GetLineCount(Caption)
      If h > .h - 2 Then h = .h - 2
      
      For i = 1 To h
         l = GetTextWidth(GetTextLine(Caption, i)) \ 8
         If l > .w - 2 Then
            tmp += Left(GetTextLine(Caption, i), .w - 5) + "..." + kc_enter
         Else
            tmp +=      GetTextLine(Caption, i)                   + kc_enter
         EIf
      Next
      Caption = tmp
      
      oCol = Color
      Color col And 15, col Shr 4
      Locate .t, .l
      ?     Chr(201) + String(.w - 2, 205) + Chr(187)
      For i = 2 To .h - 1
         Locate .t + i - 1, .l
         ?  Chr(186) + String(.w - 2,  32) + Chr(186)
      Next
      Locate .t + .h - 1, .l
      ?     Chr(200) + String(.w - 2, 205) + Chr(188)
      
      lsp = (.h - 2 - h) \ 2
      For i = 1 To h
         tmp = GetTextLine(Caption, i)
         csp = (.w - Len(tmp) - 2) \ 2
         Locate .t + i + lsp, .l + 1 + csp
         ? tmp
      Next
      
      ' not able to use the func's directly in the color statement.
      l = LoWord(oCol)
      h = HiWord(oCol)
      Color l, h
   EWith
   
ESub
'------------------------------------------------------------------------------'
Sub DrwTxtDlg (Caption AStr, Text AStr = "", posi As DTC.Rect, col AInt)
   DInt l, h, i
   DInt oCol
   DStr tmp
   
   oCol = Color
   
   With posi
      Caption = GetTextLine(Caption, 1)
      l = Len(Caption)
      If l > .w Then Caption  = Left(Caption, .w - 3) + "..."
      If l < .w Then Caption += String(.w - l, 32)
      
      Locate .t, .l
      Color col, col Shr 4
      ? Caption
      
      
      
      Color col Shr 8, col Shr 12
      
      h = GetLineCount(Text)
      If h > .h - 1 Then h = .h - 1
      If h < .h - 1 Then Text += String(.h - h - 1, 13) : h = .h - 1
      
      For i = 1 To h
         l = GetTextWidth(GetTextLine(Text, i)) \ 8
         If l > .w Then
            tmp += Left(GetTextLine(Text, i), .w) + kc_enter
         Else
            tmp +=      GetTextLine(Text, i)      + kc_enter
         EIf
      Next
      Text = tmp
      
      For i = 1 To h
         tmp = GetTextLine(Text, i)
         l = Len(tmp)
         If l < .w Then tmp += String(.w - l, 32)
         Locate .t + i, .l
         ? tmp
      Next
      
   EWith
   
   ' not able to use the func's directly in the color statement.
   l = LoWord(oCol)
   h = HiWord(oCol)
   Color l, h
ESub
'------------------------------------------------------------------------------'
Sub DrwTxtScroll(v AInt, max AInt, posi As DTC.Rect, col AInt = &H70, hscroll AInt = 0)
   DInt oCol, i, p
   
   oCol = Color
   
   With posi
      Color col, col Shr 4
      If hscroll Then
         p = (v / max) * (.w - 3) + 1
         .h = 1
         Locate .t, .l     : ? Chr( 27) + String(.w - 2, 176) + Chr( 26)
         Locate .t, .l + p : ? Chr(219)
      Else
         p = (v / max) * (.h - 3) + 1
         .w = 1
         Locate .t, .l : ? Chr(24)
         For i = 2 To .h - 1
            Locate .t +  i - 1, .l : ? Chr(176)
         Next
         Locate    .t + .h - 1, .l : ? Chr( 25)
         Locate    .t +  p    , .l : ? Chr(219)
      EIf
      
   EWith
   
   ' not able to use the func's directly in the color statement.
   i = LoWord(oCol)
   p = HiWord(oCol)
   Color i, p
ESub
'------------------------------------------------------------------------------'
Sub InpEx  (         Text     AStr = ""   , _
             ByRef   l       AInt        , _
             ByRef   c       AInt        , _
             ByRef   Ans     AStr  = ""  , _
                     col     AInt  = &H0F, _
                     Flags   AInt  =  0  , _
                     maxLen  AInt  =  0  , _
                     Cursor  AInt  =  0  , _
                     mxShLn  AInt  =  0    _
            )
   
   DStr SwAns
   DInt ins = -1, switchCursor
   
   DInt cc, ca
   DInt Ascii
   DStr key
   
   cc = c
   
   If maxLen < 0 Then maxLen = 0
   If mxShLn < 0 Then mxShLn = 0
   If Cursor < 0 Then Cursor = 0
   If mxShLn And (Cursor = 0) Then Cursor = 1
   
   If (Len(Ans) > maxlen) And maxlen Then Ans = Left(Ans, maxlen)
   
   Color col, col Shr 4
   
   If Len(Text) Then 
      Locate l, c : ? Text + Chr(13)
      c += Len(Text) + 1
   EIf
   
   If mxShLn > 0 Then Locate l, c : Color col, col Shr 4 : ? String(mxShLn, 32)
   
   SwAns = PSwAns(Ans, mxShLn, Cursor, Flags)
   If Len(SwAns) Then
      Locate l, c : ? SwAns
   EIf
   
   Do
      SwAns = PSwAns(Ans, mxShLn, Cursor, Flags)
      Color col, col Shr 4 : Locate l, c : ? SwAns
      
      If (Cursor > 0) And ((Flags And DWI_NoVisCursor) = 0) Then
         ca = Screen(l, cc, 0)
         Locate l, cc : Color col, col Shr 4 : ? Chr(ca)   ' restore old char
         
         If Cursor <= mxShLn Then
            cc = Len( Left(SwAns, Cursor - 1) ) + c
            ca = Screen(l, cc, 0)
            Locate l, cc : Color col Shr 4, col : ? Chr(ca)   ' format new char
         EIf
      EIf
      
      key = WaitForKey(Flags And DWI_NumbersOnly, -1)
      
      If Len(key) Then
         SelC Key
         Case kc_back
            If Cursor = 0 Then SwitchCursor = -1 : Cursor = Len(Ans) + 1
            If Len(Ans) And (Cursor > 1) Then
               Color col, col Shr 4
               Locate l, cc - 1             : ? " "
               Locate l, c + Len(SwAns) - 1 : ? " "
               Ans = Left(Ans, Cursor - 2) + Right(Ans, Len(Ans) - Cursor + 1)
               Cursor -= 1
            Else
               Beep
            EIf
            If SwitchCursor Then SwitchCursor = 0 : Cursor = 0
            
         Case kc_del
            If Cursor Then
               If (Cursor <= Len(Ans)) Then
                  Locate l, c + Len(SwAns) - 1 : Color col, col Shr 4 : ? " "
                  Ans = Left(Ans, Cursor - 1) + Right(Ans, Len(Ans) - Cursor)
               Else
                  Beep
               EIf
            EIf
            
            
         Case kc_return
            Exit Do
            
         Case kc_esc
            
            
         Case kc_left
            If Cursor > 1 Then Cursor -= 1
            
         Case kc_right
            If Cursor And (Cursor <= Len(Ans)) Then Cursor += 1
            
         Case kc_pos1
            If Cursor Then Cursor = 1
            
         Case kc_end
            If Cursor Then Cursor = Len(Ans) + 1
            
         Case kc_ins
            ins = Not(ins)
            
            
         Case Else
            If ( Len(Ans) < maxLen) Xor ( maxLen < 1 ) Then
               If Cursor = 0 Then SwitchCursor = -1 : Cursor = Len(Ans) + 1
               
               If ins Then
                  Ans = Left(Ans, Cursor - 1) + Key + Right(Ans, Len(Ans) - Cursor + 1)
                  Cursor += 1
                  If SwitchCursor Then SwitchCursor = 0 : Cursor = 0
               Else
                  Ans = Left(Ans, Cursor - 1) + Key + Right(Ans, Len(Ans) - Cursor    )
                  Cursor += 1
                  If SwitchCursor Then SwitchCursor = 0 : Cursor = 0
               EIf
               
            EIf
         ESel
      EIf
   Loop
   
   Locate l, cc : Color col, col Shr 4 : ? Chr(ca)
ESub
'------------------------------------------------------------------------------'