/'
 GfxString.bi
 
 This module contains routines, that base on DRAW STRING, but have got more features.
 
 - DrawStringX
   Draws some Text, allowing some flags, and easyly use a Font without changing Syntax.
   Interprets kc_CR as line-break
 
 - GfxInp
   Just like INPUT in Text modes, but designed for Gfx-Modes, using DrawStringX and giving even more features:
   + Pre-Defined Input-Text
   + Maximum-Input-Length
   + Maximum-Showing-Length and Text-Scrolling
   + full Cursor features
'/

DProc DrawStringX OLoad _
   (      Text    AStr        , _
    ByRef x       AInt        , _
    ByRef y       AInt        , _
          Font    AAnyPtr     , _
          Flags   AInt     = 0, _
          target  AAnyPtr  = 0  _
   )
'..............................................................................'
DProc DrawStringX _
   (      Text    AStr        , _
    ByRef x       AInt        , _
    ByRef y       AInt        , _
          fore    AInt     = 0, _
          Flags   AInt     = 0, _
          target  AAnyPtr  = 0  _
   )
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++'
DProc GfxInp OLoad _
   (      Prompt        AStr    = "", _
    ByRef x             AInt        , _
    ByRef y             AInt        , _
    ByRef Ans           AStr    = "", _
          Font          AAnyPtr     , _
          Flags         AInt    =  0, _
          maxLen        AInt    =  0, _
          Cursor        AInt    =  0, _
          MaxShowLength AInt    =  0  _
   )
'..............................................................................'
DProc GfxInp _
   (      Prompt        AStr    = "", _
    ByRef x             AInt        , _
    ByRef y             AInt        , _
    ByRef Ans           AStr    = "", _
          fore          AInt    =  0, _
          Flags         AInt    =  0, _
          maxLen        AInt    =  0, _
          Cursor        AInt    =  0, _
          MaxShowLength AInt    =  0  _
   )
'=============================================================================='
Proc DrawStringX  (      Text    AStr        , _
                   ByRef x       AInt        , _
                   ByRef y       AInt        , _
                         Font    AAnyPtr     , _
                         Flags   AInt     = 0, _
                         target  AAnyPtr  = 0)
   
   DInt lines, i, h, w
   DStr aLine
   
   If Len(Text) = 0 Then QProc
   
   h = Cast(UShort Ptr, Font)[1] - 1
   lines = GetLineCount(Text)
   
   For i = 1 To Lines
      aLine = GetTextLine(Text, i)
      DwS target, (x, y), aLine, , Font
      If (Flags And DWX_Underlined) Then 
         w = GetTextWidth(aLine, Font)
         Line (x, y + h - 1)-(x + w, y + h - 1)
      EIf
      If (Flags And DWX_Bold) Then 
         x += 1
         DwS target, (x, y), aLine, , Font
      EIf
      y += h
   Next
   
   
   x += GetTextWidth(Text, Font)
EProc
'..............................................................................'
Proc DrawStringX  (      Text    AStr        , _
                   ByRef x       AInt        , _
                   ByRef y       AInt        , _
                         fore    AInt     = 0, _
                         Flags   AInt     = 0, _
                         target  AAnyPtr  = 0)
   
   DInt lines, i, h, w
   DStr aLine
   
   If Len(Text) = 0 Then QProc
   
   h = DWX_StdFontHeight
   lines = GetLineCount(Text)
   
   For i = 1 To Lines
      aLine = GetTextLine(Text, i)
      DwS target, (x, y), aLine, fore
      If (Flags And DWX_Underlined) Then
         w = GetTextWidth(aLine)
         Line (x, y + h - 1)-(x + w, y + h - 1)
      EIf
      If (Flags And DWX_Bold) Then 
         x += 1
         DwS target, (x, y), aLine, fore
      EIf
      y += h
   Next
   
   x += GetTextWidth(Text)
EProc
'------------------------------------------------------------------------------'
Proc GfxInp _
   (      Text   AStr    = "", _
    ByRef x      AInt        , _
    ByRef y      AInt        , _
    ByRef Ans    AStr    = "", _
          Font   AAnyPtr     , _
          Flags  AInt    =  0, _
          maxLen AInt    =  0, _
          Cursor AInt    =  0, _
          mxShLn AInt    =  0  _
   )
   
   DStr SwAns
   DInt ins = -1, switchCursor
   
   DInt tx, ty, cx
   DInt Ascii, Bgr, fh
   DStr key
   
   If maxLen < 0 Then maxLen = 0
   If mxShLn < 0 Then mxShLn = 0
   If Cursor < 0 Then Cursor = 0
   If mxShLn And (Cursor = 0) Then Cursor = 1
   
   If (Len(Ans) > maxlen) And maxlen Then Ans    = Left(Ans, maxlen)
   
   SwAns = PSwAns(Ans, mxShLn, Cursor, Flags)
   Bgr   = HiWord(Color())
   fh    = Cast(UShort Ptr, Font)[1] - 1
   
   If Len(Text) Then
      DwX Text + Chr(32), x, y, Font, Flags
      ScrCpy
      y -= fh
   EIf
   tx = x
   ty = y
   
   If Len ( SwAns) Then 
      Lin ( x, y )-( x + GetTextWidth(SwAns, Font), y + GetTextHeight(SwAns, Font) - 1), Bgr, BF
      DwX SwAns, x, y, Font, Flags
      ScrCpy
   EIf
   
   x = tx
   y = ty
   
   Do
      SwAns = PSwAns(Ans, mxShLn, Cursor, Flags)
      Lin ( x, y )-( x + GetTextWidth(SwAns, Font), y + GetTextHeight(SwAns, Font) - 1), Bgr, BF
      DwX SwAns, x, y, Font, Flags
      ScrCpy
      
      x = tx
      y = ty
      
      If (Cursor > 0) And ((Flags And DWI_NoVisCursor) = 0) Then
         cx = GetTextWidth( Left(SwAns, Cursor - 1), Font ) + tx
         Line (cx, y)-(cx, y + fh - 1)
      EIf
      
      key = WaitForKey(Flags And DWI_NumbersOnly, -1)
      
      SelC key
      Case kc_Back
         If Cursor = 0 Then SwitchCursor = -1 : Cursor = Len(Ans) + 1
         If Len ( Ans ) And (Cursor > 1) Then
            Lin (tx, y)-(tx + GetTextWidth(SwAns, Font), y + fh - 1), Bgr, BF
            Ans = Left(Ans, Cursor - 2) + Right(Ans, Len(Ans) - Cursor + 1)
            Cursor -= 1
         Else
            Beep
         EIf
         If SwitchCursor Then SwitchCursor = 0 : Cursor = 0
         
      Case kc_Del
         If Cursor Then
            If (Cursor <= Len(Ans)) Then
               Line (tx, y)-(tx + GetTextWidth(SwAns, Font), y - fh - 1), Bgr, BF
               Ans = Left(Ans, Cursor - 1) + Right(Ans, Len(Ans) - Cursor)
            Else
               Beep
            EIf
         EIf
         
         
      Case kc_Return
         Exit Do
         
      Case kc_Esc
         
         
      Case kc_Left
         If Cursor > 1 Then Cursor -= 1
         
      Case kc_Right
         If Cursor And (Cursor <= Len(Ans)) Then Cursor += 1
         
      Case kc_Pos1
         If Cursor Then Cursor = 1
         
      Case kc_End
         If Cursor Then Cursor = Len(Ans)
         
         
      Case kc_Ins
         ins = Not(ins)
         
         
      Case Else
         If ( Len(Ans) < maxLen  ) Xor ( maxLen < 1 ) Then
            If Cursor = 0 Then SwitchCursor = -1 : Cursor = Len(Ans) + 1
            
            If ins Then
               Ans = Left(Ans, Cursor - 1) + Key + Right(Ans, Len(Ans) - Cursor + 1)
               Cursor += 1
               If SwitchCursor Then SwitchCursor = 0 : Cursor = 0
            Else
               Ans = Left(Ans, Cursor - 1) + Key + Right(Ans, Len(Ans) - Cursor    )
               Cursor += 1
               If SwitchCursor Then SwitchCursor = 0 : Cursor = 0
            EIf
            
         EIf
      ESel
   Loop
   
End Sub
'..............................................................................'
Proc GfxInp _
   (      Text   AStr    = "", _
    ByRef x      AInt        , _
    ByRef y      AInt        , _
    ByRef Ans    AStr    = "", _
          fore   AInt    =  0, _
          Flags  AInt    =  0, _
          maxLen AInt    =  0, _
          Cursor AInt    =  0, _
          mxShLn AInt    =  0  _
   )
   
   DStr SwAns
   DInt ins = -1, switchCursor
   
   DInt tx, ty, cx
   DInt Ascii, Bgr, fh
   DStr key
   
   If maxLen < 0 Then maxLen = 0
   If mxShLn < 0 Then mxShLn = 0
   If Cursor < 0 Then Cursor = 0
   If mxShLn And (Cursor = 0) Then Cursor = 1
   
   If (Len(Ans) > maxlen) And maxlen Then Ans = Left(Ans, maxlen)
   
   Bgr = HiWord(Color())
   fh = DWX_StdFontHeight
   
   If Len(Text) Then 
      DwX Text + Chr(32), x, y, fore, Flags
      ScrCpy
      y -= fh
   End If
   tx = x
   ty = y
   
   SwAns = PSwAns(Ans, mxShLn, Cursor, Flags)
   If Len(SwAns) Then
      Line ( x, y )-( x + GetTextWidth(SwAns), y + GetTextHeight(SwAns) - 1), Bgr, BF
      DwX SwAns, x, y, fore, Flags
      ScrCpy
   EIf
   
   x = tx
   y = ty
   
   Do
      SwAns = PSwAns(Ans, mxShLn, Cursor, Flags)
      Line ( x, y )-( x + GetTextWidth(SwAns), y + GetTextHeight(SwAns) ), Bgr, BF
      DwX SwAns, x, y, fore, Flags
      ScrCpy
      
      x = tx
      y = ty
      
      If (Cursor > 0) And ((Flags And DWI_NoVisCursor) = 0) Then
         cx = GetTextWidth( Left(SwAns, Cursor - 1) ) + tx
         Line (cx, y)-(cx, y + fh - 1)
      End If
      
      key = WaitForKey(Flags And DWI_NumbersOnly, -1)
      
      If Len(key) Then
         SelC Key
         Case kc_back
            If Cursor = 0 Then SwitchCursor = -1 : Cursor = Len(Ans) + 1
            If Len(Ans) And (Cursor > 1) Then
               Line (tx, y)-(tx + GetTextWidth(SwAns), y + fh - 1), Bgr, BF
               Ans = Left(Ans, Cursor - 2) + Right(Ans, Len(Ans) - Cursor + 1)
               Cursor -= 1
            Else
               Beep
            EIf
            If SwitchCursor Then SwitchCursor = 0 : Cursor = 0
            
         Case kc_del
            If Cursor Then
               If (Cursor <= Len(Ans)) Then
                  Line (tx, y)-(tx + GetTextWidth(SwAns), y + fh - 1), Bgr, BF
                  Ans = Left(Ans, Cursor - 1) + Right(Ans, Len(Ans) - Cursor)
               Else
                  Beep
               EIf
            EIf
            
            
         Case kc_return
            Exit Do
            
         Case kc_esc
            
            
         Case kc_left
            If Cursor > 1 Then Cursor -= 1
            
         Case kc_right
            If Cursor And (Cursor <= Len(Ans)) Then Cursor += 1
            
         Case kc_pos1
            If Cursor Then Cursor = 1
            
         Case kc_end
            If Cursor Then Cursor = Len(Ans)            
            
         Case kc_ins
            ins = Not(ins)
            
            
         Case Else
            If ( Len(Ans) < maxLen ) Xor ( maxLen < 1 ) Then
               If Cursor = 0 Then SwitchCursor = -1 : Cursor = Len(Ans) + 1
               
               If ins Then
                  Ans = Left(Ans, Cursor - 1) + Key + Right(Ans, Len(Ans) - Cursor + 1)
                  Cursor += 1
                  If SwitchCursor Then SwitchCursor = 0 : Cursor = 0
               Else
                  Ans = Left(Ans, Cursor - 1) + Key + Right(Ans, Len(Ans) - Cursor    )
                  Cursor += 1
                  If SwitchCursor Then SwitchCursor = 0 : Cursor = 0
               EIf
               
            EIf
         ESel
      EIf
   Loop
   
End Sub
'=============================================================================='
