/'
 Shortwords.bi
 
 This file contains a lot of Defines, that make programming easier, because they replace
 long expressions by short words.
 
 The Short words are sorted to theme blocks:
 
 - Variable Declaration
   Within this block, there are defines, that replace Statements with As, Dim, Shared, ...
   As there needs to be one for every type, the type-names have got shortwords too.
   They are...
   Byt  - Byte
   UByt - UByte
   Shr  - Short
   UShr - UShort
   Int  - Integer
   UInt - UInteger
   Lng  - LongInt
   ULng - ULongInt
   Str  - String
   ZStr - ZString
   WStr - WString
   Ptr  - Pointer
   These aren't defined on their own, but used as part of other defines.
   For example, DSInt refers to an Integer, while DSIntPtr refers to an Integer Pointer.
   
   + As
      Short Words contain of A + Typename, like 'AInt' for 'As Integer'
      
   + Dim
      Short Words contain of D + Typename, like 'DInt' for 'Dim As Integer'
      There's also a symbol 'DA' for 'Dim As' (might be used for UDTs)
   
   + Dim Shared
      Short Words contain of DS + Typename, like 'DSInt' for 'Dim Shared As Integer'
      There's also a symbol 'DSA' for 'Dim Shared As'
      
   + Other
      As they are not so common, there are only the 'Statement As' Versions, not explicitly versions for every type.
      To be preciese, ths block contains:
         RePre  for Redim Preserve
         RePreA for Redim Preserve As
         Cmn    for Common
         CmnA   for Common As
         CmnS   for Common Shared
         CmnSA  for Common Shared As
         
 - Block Statements
   here are a lot of Statements, that are used in block statements, like If...End If.
   All End-Versions are made into E + Statement, like 'EWith' for 'End With'. The same was 
   made with The Exit-Statements: Q (for quit) + Statement, like QFunc for 'Exit Function'
   Look at what was replaced on your own!
   
 - Allocates
   Here are four short versions for the four long Allocate-Methods (Re-, De-, C- and Allocate)
   RAlloc, DAlloc, CAlloc, and Alloc.
 
 - Gfx
   Contains TLS (Three Letter Shortcuts) for every common Gfx Statement like Cir for Circle.
   This is useful, as you maybe want to format your texts number-below-number.
   
 - Mouse
   Short Mouse commands like HideMouse for SetMouse , , 0.
   
 - Misc
   Short words for other statements, that fit in no other category.
'/
'=============================================================================='
'  Variable Declaration
'   As...
#Define AByt      As Byte
#Define AUByt     As UByte
#Define ABytPtr   As Byte Ptr
#Define AUBytPtr  As UByte Ptr

#Define AShr      As Short
#Define AUShr     As UShort
#Define AShrPtr   As Short Ptr
#Define AUShrPtr  As UShort Ptr

#Define AInt      As Integer
#Define AUInt     As UInteger
#Define AIntPtr   As Integer Ptr
#Define AUIntPtr  As UInteger Ptr

#Define ALng      As LongInt
#Define AULng     As ULongInt
#Define ALngPtr   As LongInt Ptr
#Define AULngPtr  As ULongInt Ptr

#Define ASng      As Single
#Define ADbl      As Double
#Define ASngPtr   As Single Ptr
#Define ADblPtr   As Double Ptr

#Define AStr      As String
#Define AZStr     As ZString
#Define AWStr     As WString
#Define AStrPtr   As String Ptr
#Define AZStrPtr  As ZString Ptr
#Define AWStrPtr  As WString Ptr

#Define AAny      As Any
#Define AAnyPtr   As Any Ptr
'..............................................................................'
'  Dim's
'   Standard...
#Define DByt      Dim AByt
#Define DUByt     Dim AUByt
#Define DBytPtr   Dim ABytPtr
#Define DUBytPtr  Dim AUBytPtr

#Define DShr      Dim AShr
#Define DUShr     Dim AUShr
#Define DShrPtr   Dim AShrPtr
#Define DUShrPtr  Dim AUShrPtr

#Define DInt      Dim AInt
#Define DUInt     Dim AUInt
#Define DIntPtr   Dim AIntPtr
#Define DUIntPtr  Dim AUIntPtr

#Define DLng      Dim ALng
#Define DULng     Dim AULng
#Define DLngPtr   Dim ALngPtr
#Define DULngPtr  Dim AULngPtr

#Define DSng      Dim ASng
#Define DDbl      Dim ADbl
#Define DSngPtr   Dim ASngPtr
#Define DDblPtr   Dim ADblPtr

#Define DStr      Dim AStr
#Define DStrPtr   Dim AStrPtr
#Define DZStr     Dim AZStr
#Define DZStrPtr  Dim AZStrPtr
#Define DWStr     Dim AWStr
#Define DWStrPtr  Dim AWStrPtr

#Define DAny      Dim AAny
#Define DAnyPtr   Dim AAny Ptr

#Define DA        Dim As
'..............................................................................'
'   Shared...
#Define DSByt     Dim Shared AByt
#Define DSUByt    Dim Shared AUByt
#Define DSBytPtr  Dim Shared ABytPtr
#Define DSUBytPtr Dim Shared AUBytPtr

#Define DSShr     Dim Shared AShr
#Define DSUShr    Dim Shared AUShr
#Define DSShrPtr  Dim Shared AShrPtr
#Define DSUShrPtr Dim Shared AUShrPtr

#Define DSInt     Dim Shared AInt
#Define DSUInt    Dim Shared AUInt
#Define DSIntPtr  Dim Shared AIntPtr
#Define DSUIntPtr Dim Shared AUIntPtr

#Define DSLng     Dim Shared ALng
#Define DSULng    Dim Shared AULng
#Define DSLngPtr  Dim Shared ALngPtr
#Define DSULngPtr Dim Shared AULngPtr

#Define DSSng     Dim Shared ASng
#Define DSDbl     Dim Shared ADbl
#Define DSSngPtr  Dim Shared ASngPtr
#Define DSDblPtr  Dim Shared ADblPtr

#Define DSStr     Dim Shared AStr
#Define DSStrPtr  Dim Shared AStrPtr
#Define DSZStr    Dim Shared AZStr
#Define DSZStrPtr Dim Shared AZStrPtr
#Define DSWStr    Dim Shared AWStr
#Define DSWStrPtr Dim Shared AWStrPtr

#Define DSAny     Dim Shared AAny
#Define DSAnyPtr  Dim Shared AAnyPtr

#Define DSA       Dim Shared As
'..............................................................................'
'   Other
#Define RePre     Redim Preserve
#Define RePreA    Redim Preserve As
#Define Cmn       Common
#Define CmnA      Common As
#Define CmnS      Common Shared
#Define CmnSA     Common Shared As
'------------------------------------------------------------------------------'
'  Block Statements

'   Procedures
#Define Proc      Sub
#Define Func      Function
#Define Prop      Property
#Define Oper      Operator
#Define CTor      Constructor
#Define DTor      Destructor

#Define DSub      Declare Sub
#Define DProc     Declare Proc
#Define DFunc     Declare Func
#Define DProp     Declare Prop
#Define DOper     Declare Oper
#Define DCTor     Declare CTor
#Define DDTor     Declare DTor

#Define ESub      End Sub
#Define EProc     End Proc
#Define EFunc     End Func
#Define EProp     End Prop
#Define EOper     End Oper
#Define ECTor     End CTor
#Define EDTor     End DTor

#Define OLoad     Overload

#Define EAsm      End Asm

#Define Priv      Private
#Define Publ      Public

'   Conditions
#Define SelC      Select Case
#Define ESel      End Select
#Define EIf       End If

'  Types
#Define ETyp      End Type
#Define EType     End type
#Define EEnu      End Enum
#Define EEnum     End Enum
#Define EUni      End Union
#Define EUnion    End Union
#Define EWit      End With
#Define EWith     End With

'   Exit
#Define QDo       Exit Do
#Define QFor      Exit For
#Define QWhile    Exit While
#Define QSub      Exit Sub
#Define QProc     Exit Proc
#Define QFunc     Exit Function
#Define QSel      Exit Select
#Define QProp     Exit Property
#Define QOper     Exit Operator
'------------------------------------------------------------------------------'
'  Allocates
#Define  Alloc     Allocate
#Define CAlloc    CAllocate
#Define DAlloc    DeAllocate
#Define RAlloc    ReAllocate
'------------------------------------------------------------------------------'
'  Gfx
#Define ImgCre    ImageCreate
#Define ImgDes    ImageDestroy

#Define ScrSet    ScreenSet
#Define Scr2Sides ScrSet 0, 1
#Define ScrCpy    ScreenCopy

#Define Pse       Pset
#Define Pre       PreSet
#Define Lin       Line
#Define Cir       Circle
#Define Pnt       Paint
#Define DwS       Draw String
#Define DwX       DrawStringX
#Define DwI       GfxInp
'------------------------------------------------------------------------------'
'  Mouse
#Define SMou      SetMouse
#Define GMou      GetMouse
#Define HideMouse SMou , , 0
#Define ShowMouse SMou , , 1
'------------------------------------------------------------------------------'
'  Misc
#Define Jmp       Goto
#Define Use       Using
#Define Slp       Sleep

#Define UBnd      UBound
#Define LBnd      LBound